// Planta_MOTORCC_HW1.cpp: Implementación de proceso de planta para motorCC con discretizador HW1
// El discretizador HW1 se comunica con el motor real y a la vez con el controlador vía bus

// #include "sistemas/funciones_periodicas.h"
// #include "sistemas/motorcc.h"
// #include "sistemas/constante.h"
#include "base.h"

#include "microcontroladores/discretizador_motorcc_hw1.h"

#include <iostream>

int main()
{	

// CREACION DE WATCHDOGS ---------------------------------------------------------------------

// CREACION DE CONTROLADORES -----------------------------------------------------------------
	
// CREACION DE DISPOSITIVOS DE FISICOS DE PLANTA, GENERADORES Y FUNCIONES MATEMATICAS -------- 

// CREACION DE BUSES -------------------------------------------------------------------------
	
	Bus *bus = new Bus(3801, PROCESO_PLANTA);	

// CREACION DE DISCRETIZADORES ---------------------------------------------------------------
	
	Discretizador_motorcc_HW1 *discret_mot = new Discretizador_motorcc_HW1(50,4801,2,bus);		
	
// CREACION DE CONECTORES CONVENCIONALES -----------------------------------------------------	
	
										   
// CREACION DE GRABADORES --------------------------------------------------------------------
	
	
// CREACION DE LOS CONECTORES DE RECOLECCION DE DATOS (para grabar)---------------------------	
											
	
// CONECTAMOS TODOS LOS COMPONENTES	----------------------------------------------------------		

	discret_mot -> asociar(); // Asociación necesaria al bus, aunque no se conecte
	
// CREAMOS SONDAS PARA GRABAR DATOS A ARCHIVO EXTERNO ----------------------------------------		
	

// CREAMOS EL MENU INTERACTIVO ---------------------------------------------------------------
	
	Interactivo menu;
	
// REGISTRAMOS TODOS LOS DISPOSITIVOS EN EL MENU INTERACTIVO

	menu.registro(discret_mot, "Discretizador motor HW1");
	menu.registro(bus, "Bus");
	
// EJECUTAMOS MENU INTERACTIVO ---------------------------------------------------------------

	menu.ejecutar(true); // ejecutamos y liberamos todos los objetos llamando a sus destructores (true)	
	
	std::cout << "\nSalida del programa PLANTA\n";  // Mensaje final
		
	return 0;
	
}
